#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Dec  4 14:11:02 2023

@author: anton
"""

from SLiCAP import *

prj = initProject('A1 input stage noise design')

from specifications import *
from noise1 import *         # Check noise budget inductor + termination
from noise2 import *         # Determine noise budget for R_i and calculate R_i

NP = False

while NP == False:
    NP = input("Enter 'n' or 'p' for NMOS or CMOS input stage, respectively:\n>>> ")[0].lower()
    if NP != "n" and NP != "p":
        NP = False
    elif NP == "n":
        # NMOS input stage design
        from noiseCissGm_n import *      # Determine noise budget for NMOS and determine g_m and C_iss
        from noiseWLI_n import *         # Select NMOS channel length and determine I_DS, W, and M
        from checkModel_n import *       # Compare the EKV model of the device and BSIM3
        # The following imports require the module pyLTspice and an up-to-date version of SLiCAP
        from checkNoiseN import *        # Verify noise with LTspice, single CS input and ideal controller
        from oneStage_n import *         # Evaluation of the small-signal bandwidth and midband accuracy of a single-stage amplifier
    elif NP == "p":
        # PMOS input stage design
        from noiseCissGm_p import *      # Determine noise budget for PMOS and determine g_m and C_iss
        from noiseWLI_p import *         # Select PMOS channel length and determine I_DS, W, and M
        from checkModel_p import *       # Compare the EKV model of the device and BSIM3
        # The following imports require the module pyLTspice and an up-to-date version of SLiCAP
        from checkNoiseP import *        # Verify noise with LTspice, single CS input and ideal controller
        from oneStage_p import *         # Evaluation of the small-signal bandwidth and midband accuracy of a single-stage amplifier
        from checkNoiseAmpP import *     # Verify noise of different implementations with LTspice
        from checkBandwidthAmpP import * # Verify bandwidth of different implementations with LTspice
        from checkSinewaveAmpP import *  # Verify large-signal sinewave response of different implementations with LTspice